--[[Notes:
- All basic functions of the original Regicide are finished. I'll likely release it here, and then continue to work on it.

- fleeUnit is for AI, but it's still very experimental and somewhat bulky. Maybe not enough to significantly affect performance, but to stay safe I'll look into ways to trim it and make it more optimized.

- AI is DUMB. AI+ Mod helps a little bit, but it still does very, very stupid things. 

- 
]]--
local iCurrentGameMode = GameConfiguration.GetValue("Regicide");
local bMass  = GameConfiguration.GetValue("MassRegicide");
local bMor = GameConfiguration.GetValue("Morale");
local bAll = GameConfiguration.GetValue("AllForOne");
local bisRegicide = false;
local bisDemiDeicide = false;
--If current # of Kings is less than ThresholdNumber, end game
local iThreshholdNumber = ((bMass and bAll) and 7) or 1;
local unitType = -1;
--Does not need to be serialized. Since it's just counting by units, I can just fill it upon initialization of the game
local tNumOfKings = {}

-- ===========================================================================
function Initialize()
	print("Initializing RegScript");

	if iCurrentGameMode == "DEACTIVATED" then
		print("RegScript Deactivated");
	end
	if iCurrentGameMode == "REGICIDE" then
		print("RegScript on Regicide Mode");
		bisRegicide = true;
	end
	if iCurrentGameMode == "DEMI_DEICIDE" then
		print("RegScript on Deicide Mode");
		bisDemiDeicide = true;
	end
	
	print("Morale: " .. tostring(bMor));
	print("All For One: " .. tostring(bAll));
	print("Mass Regicide: " .. tostring(bMass));
	
	unitType = ((bMor and GameInfo.Units["UNIT_STRONG_KING"].Index) or ((bisRegicide and GameInfo.Units["UNIT_KING"].Index) or -1));
	
	tNumOfKings = {};
	print("Finished Initializing RegScript");
end

-- ===========================================================================
function InitializeNewGame()
 print("New Game with Regicide Mod is starting");
 if unitType ~= -1 then
	 local aPlayers = PlayerManager.GetAliveMajors();
		for i, Player in ipairs(aPlayers) do
			local x = Player:GetStartingPlot():GetX();
			local y = Player:GetStartingPlot():GetY();
				Player:GetUnits():Create(unitType, x, y):GetID();
			if bMass then
				for j = 0, 5 do
					Player:GetUnits():Create(unitType, x, y):GetID();
				end
			end
			--NOT equal to the threshold #
			print("Assigning table values to Player #" .. tostring(Player:GetID()));
			tNumOfKings[Player:GetID()] = (bMass and 7) or 1;
		end
	end
end
LuaEvents.NewGameInitialized.Add(InitializeNewGame);

-- ===========================================================================
function OnPlayerTurnActivated(iPlayer)
	--print("1");
	Player = Players[iPlayer];
	--print("2");
	if unitType ~= -1 then
	--	print("3");
		if Player:IsMajor() and not Player:IsBarbarian() and tNumOfKings[iPlayer] == nil then
	--		print("4");
			for i, pPlayer in ipairs(Players) do
				if pPlayer:IsMajor() and pPlayer:IsAlive() and not pPlayer:IsBarbarian() then
		--			print("5");
					print("Assigning table values to Player #" .. tostring(pPlayer:GetID()));
					tNumOfKings[pPlayer:GetID()] = getNumKings(pPlayer);
				end
			end
		end
		--[[if Player:IsMajor() and not Player:IsBarbarian() then
			for i, pUnit in Player:GetUnits():Members() do
			print(pUnit:GetID());
				if pUnit:GetType() == unitType then
					--fleeDanger(pUnit, Player);
					--Will be added after some final touches
				end
			end
		end ]]--
	end
end 

--Simple method to prevent some AI king deaths not done by players
--Get Vectors from each Enemy Unit to Unobstructed Paths the Unit can take
--Find average magnitude of vectors to plots
--Plot with highest average magnitude from enemy units will be the one chosen to move towards to
function fleeDanger(pUnit, Player)
		--Look In 2 tile radius for enemies
	local tObstructedPlots = {}
	local tEnemyPlots = {}
	local tAvgPlotMagnitudes = {}
	local tPossiblePlots = {}
	local biggestPlotAvg = 0;
	local biggestPlot = nil;
	--Working in a 5x5 block centered around the King Unit
	--WIP: Lot's of Debug Statements still
	for j = pUnit:GetX() - 2, pUnit:GetX() + 2 do
		for k = pUnit:GetY() - 2, pUnit:GetY() + 2 do
			print("Why")
			print(j)
			print(k)
			currPlot = Map.GetPlot(j,k);
			if Units.AreUnitsInPlot(currPlot) and Units.GetUnitCountInPlot(currPlot) > 0  then
				--Units not working, for some reason, unable to get the actual units on a plot. Look into this more.
				--For now search through all units
				print("are");
				local UnitOnPlot = nil
			
				for l, pPlayer in ipairs(Players) do
				print("you");
				if pPlayer:IsAlive() then
						for m, plotUnit in pPlayer:GetUnits():Members() do
						print("reading");
							if plotUnit:GetX() == currPlot:GetX() and plotUnit:GetY() == currPlot:GetY() then
							print("these");
								UnitOnPlot = plotUnit;
								table.insert(tObstructedPlots, currPlot);
								print("debug");
							end
						end
					end
				end
				print("messages");
				print(UnitOnPlot:GetName());
				print(UnitOnPlot:GetOwner());
				Owner = Players[UnitOnPlot:GetOwner()];
				if Owner:IsBarbarian() or Player:GetDiplomacy():IsAtWarWith(UnitOnPlot:GetOwner()) then
					table.insert(tEnemyPlots, currPlot);
					print(", are");
				end
			elseif currPlot:IsImpassable() then
				print("you");
				table.insert(tObstructedPlots, currPlot);	
			elseif not isObstructed(tObstructedPlots, pUnit:GetX(), pUnit:GetY(), currPlot:GetX(), currPlot:GetY()) then
				print("bored?");
				--This plot is neither an impassible plot, nor a plot with an enemy unit on it nor
					table.insert(tPossiblePlots, currPlot);
			end
			
		end
	end
	--No point moving unless there is good reason to do so: i.e  an enemy is nearby
	if tEnemyPlots[1] ~= nil then
		for i, PossiblePlot in ipairs(tPossiblePlots) do
			print(PossiblePlot:GetX());
			local avg = 0;
			for j,  EnemyPlot in ipairs(tEnemyPlots) do
				print(EnemyPlot:GetX());
				local vecX, vecY = getVector(EnemyPlot:GetX(), EnemyPlot:GetY(), PossiblePlot:GetX(), PossiblePlot:GetY());
				local magnitude = math.sqrt(((vecX^2) + (vecY^2)));
				avg = avg + magnitude;
			end
			avg = avg / #tEnemyPlots;
			if avg > biggestPlotAvg then
				biggestPlotAvg = avg;
				biggestPlot = PossiblePlot;
			end
		end
		--print(biggestPlotAvg);
	--	print(biggestPlot);
		if biggestPlot ~= nil then
			UnitManager.RestoreMovement(pUnit);
			UnitManager.MoveUnit(pUnit, biggestPlot:GetX(), biggestPlot:GetY())
			--print("test");
		end
	end
end

--Find if path would lead to head on collision with unit or impassable object
function isObstructed(tPlots, uX, uY, PlotX, PlotY)
	--Enemy/Impassible Plots in tX and tY
	for i, PlotInTable in ipairs(tPlots) do
		local vecXToPlot, vecYToPlot = getVector(uX, uY, PlotX, PlotY);
		local vecXToObj, vecYToObj = getVector(uX, uY, PlotInTable:GetX(), PlotInTable:GetY())
		--If Vectors are parallel/equal(And therefore something lies in the path). Use constant 2 or equal
		if((vecXToPlot == (2 * vecXToObj) and vecYToPlot == (2 * vecYToObj))) then
			--Something obstructs the path
			return true;
		end
		end
	return false;
end

function getVector(xOne, yOne, xTwo, yTwo)
	local vecX = xTwo - xOne;
	local vecY = yTwo - yOne;
	return vecX, vecY;
end

function OnUnitRemoved(iPlayer, iUnit)
	Player = Players[iPlayer];
	local Player = Players[iPlayer];
	if unitType ~= -1 then
			local origPlayer = getOrigPlayer();
			if origPlayer ~= nil then
				tNumOfKings[origPlayer:GetID()] = tNumOfKings[origPlayer:GetID()] - 1;
			
				if getNumKings(origPlayer) < iThreshholdNumber and (origPlayer:IsMajor() and not origPlayer:IsBarbarian()) then
					destroyPlayer(origPlayer);
				end
				
			--[[	for j, pPlayer in ipairs(Players) do
						for i, pUnit in pPlayer:GetUnits():Members() do
							if pUnit ~= nil then
								if pUnit:GetType() == GameInfo.Units["UNIT_CAPTURED_KING"].Index then
									Player:GetUnits():Destroy(pUnit);
								end
							end
						end
				end]]--
			end
	end
end


function destroyPlayer(origPlayer)
	--If the # of Kings is less than the Threshold for killing off a civ, and that civ is neither a barbarian nor a city-state then: kill off that civ
	print("Destroying Player" .. tostring(origPlayer:GetID()) .. " cities due to # of Kings being below the threshold for staying alive");
	for j, pCity in origPlayer:GetCities():Members() do
		if pCity ~= nil then
			print(pCity:GetName() .. " is now being destroyed.") 
			--If submission then add city
			origPlayer:GetCities():Destroy(pCity);
		end
	end
	print("Destroying Player" .. tostring(origPlayer:GetID()) .. " units due to # of Kings being below the threshold for staying alive");
	for j, pUnit in origPlayer:GetUnits():Members() do
		if pUnit ~= nil then
			print(pUnit:GetName() .. " is now being destroyed.") 
			origPlayer:GetUnits():Destroy(pUnit);
		end
	end
	--Never called again while searching for origPlayers in OnUnitKilled
	tNumOfKings[origPlayer:GetID()] = 1000
end

function getOrigPlayer()
	local origPlayer = nil;
	for i, pPlayer in ipairs(Players) do
		if pPlayer:IsMajor() and pPlayer:IsAlive() and not pPlayer:IsBarbarian() then
	--	print(tostring(pPlayer:GetID()));
	--	print(getNumKings(pPlayer));
--		print(tNumOfKings[pPlayer:GetID()]);
			if(getNumKings(pPlayer) < tNumOfKings[pPlayer:GetID()]) then
			--	print("here");
				origPlayer = pPlayer;
				break;
			end
		end
	end
	return origPlayer;
end

function getNumKings(Player)
	local numKings = 0;
	if unitType ~= -1 then
		for i, pUnit in Player:GetUnits():Members() do
			if pUnit ~= nil then
				if pUnit:GetType() == unitType then
				--Interesting behavior, unitTypes arent cleared from the table until the turn begins. Instead, when attacked and killed, a unit is teleported to -9999, -9999. 
				--Likely for graphical reasons? Not sure why this is done, but this is the only thing I can think of.
				--For now, I will consider any unit at X=-9999 to be functionally deleted. Additions to numKings will only happen to those at values large than -9999.
				numKings = (pUnit:GetX() <= -9999) and numKings or (numKings + 1);
				--print(pUnit:GetOwner());
				--print(pUnit:GetX());
				--print(pUnit:GetY());
				end
			end
		end
		return numKings;
	end
end
--NOTE: Theoretically, a single player can't have more than 1 captured king at a single point in time. Also, when captured, demigods turn into Captured Kings as well.
function getCapturedKing(Player)
		for i, pUnit in Player:GetUnits():Members() do
			if pUnit ~= nil then
				if pUnit:GetType() == GameInfo.Units["UNIT_CAPTURED_KING"].Index then
					return pUnit;
				end
			end
		end
		return false;
end

--Function NameKings : Gives all Kings the name of their current Leader. ...Is this possible?


-- ===========================================================================
GameEvents.PlayerTurnStarted.Add(OnPlayerTurnActivated);
--Events.UnitCaptured.Add(OnUnitKilled);
--Events.UnitKilledInCombat.Add(OnUnitKilled);
Events.UnitRemovedFromMap.Add(OnUnitRemoved);
Initialize();
